############################
# STEP 1 build executable binary
############################
FROM golang:alpine AS builder 
# Install git.
# Git is required for fetching the dependencies.
RUN apk update && apk add --no-cache git

WORKDIR $GOPATH/src/labapi

COPY . .
# Fetch dependencies.
RUN go mod download
RUN go mod verify

# Build the binary.
RUN GOOS=linux GOARCH=amd64 go build -ldflags="-w -s" -o /go/bin/app ./src/main

############################
# STEP 2 build a small image
############################
FROM alpine

# Copy our static executable.
COPY --from=builder /go/bin/app /go/bin/app

# Run the hello binary.
ENTRYPOINT ["/go/bin/app"]
